#! /usr/bin/python
# -*- coding: shift_jis -*-
# -*- mode: python -*-
__version__ = 1
#
import time

def _ch2num(ch):
  num = ord(ch)
  if ord('0')<= num and num <= ord('9'):
    return num - ord('0')
  if ord('A')<= num and num <= ord('Z'):
    return num - ord('A') + 10
  if ord('a')<= num and num <= ord('z'):
    return num - ord('a') + 36
  return -1


def sdtfm2lt(ss):
  dl = sdtfm2lis(ss)
  return time.mktime((dl[0], dl[1], dl[2], dl[3], dl[4], dl[5], 0, 0, 0))

def sdtfm2lis(ss):
  (yyyy, m, d, H, M, S) = (-1, -1, -1, -1, -1, -1)
  yyyy = _ch2num(ss[0])+2000
  m = _ch2num(ss[1])
  if 2 < len(ss): d = _ch2num(ss[2])
  if 3 < len(ss): H = _ch2num(ss[3])
  if 4 < len(ss): M = _ch2num(ss[4])
  if 5 < len(ss): S = _ch2num(ss[5])
  return (yyyy, m, d, H, M, S)

def decode(ss):
  return sdtfm2lis(ss)

def sdtfm2ldtfm(sdt):
  dl = sdtfm2lis(sdt)
  fmt = '%02d%02d%02d-%02d%02d%02d'
  return fmt % (dl[0]-2000, dl[1], dl[2], dl[3], dl[4], dl[5])



def mksdtfm(yyyy=-1, m=-1, d=-1, H=-1, M=-1, S=-1):

  NS = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
  if yyyy == -1:
    return shortdate(time.time())
  if m == -1:
#    print 'yyyy=' , yyyy
    tl = time.localtime(yyyy) # float or integer is available
    return shortdate(tl.tm_year, tl.tm_mon, tl.tm_mday,
                      tl.tm_hour, tl.tm_min, tl.tm_sec)
  dstr = '%c' % NS[yyyy-2000]
  if 0 <= m: dstr += '%c' % NS[m]
  if 0 <= d: dstr += '%c' % NS[d]
  if 0 <= H: dstr += '%c' % NS[H]
  if 0 <= M: dstr += '%c' % NS[M]
  if 0 <= S: dstr += '%c' % NS[S]
  return dstr

def shortdate(yyyy=-1, m=-1, d=-1, H=-1, M=-1, S=-1): 
  return  mksdtfm(yyyy, m, d, H, M, S)

if __name__ == '__main__':
  #N353905.80E1393812.41A1842KSO.jpg
  Sdt = '842KSO'
  print 'lt=%d' % sdtfm2lt(Sdt)
  print time.localtime(sdtfm2lt(Sdt))

