#! /usr/bin/python
# -*- coding: shift_jis -*-
# -*- mode: python -*-
__version__ = 1
#
import sys, os
import getvalue

Gv = getvalue

_debug = 1


Ctbl7 = [(0, 0, 0), (1, 1, 1), (2, 2, 2), (3, 3, 3),
         (4, 4, 4), (5, 5, 5), (6, 6, 6), (7, 7, 7), 
         (0, 0, 7), (0, 5, 7), (0, 7, 4), (2, 7, 0),
         (7, 7, 0), (7, 2, 0), (7, 0, 4), (5, 0, 7)]

class s_xy:
  x = 0
  y = 0


class s_napstatus:
  colormode = 0
  currc = 7 # ok?
  backc = 0 # ok?
  lastp = s_xy()


Nst = s_napstatus()
Nst.lastp.x = 0

def add_Nst_lastp(a, b):
  Nst.lastp.x += a
  Nst.lastp.y += b

def c7toRGB(c7):
  cRGB = [ (c7[0]*255/7),  (c7[1]*255/7), (c7[2]*255/7)]
  return cRGB

def dpr(ss):
  if 0 < _debug:
    print(ss)

def Dpr(ss):
  if 1 < _debug:
    print(ss)

def _cmp(sl, ss):
  if len(sl) < len(ss):
    #print('assert: bad logic, %s < %s' % (sl, ss))
    return False
  if sl.lower()[:len(ss)] == ss.lower():
    return True
  return False


def proc_selectcolor(ln):
  (ac, av) = Gv.getoptsc(ln, 'selectcolor')
  Nst.colormode = ac
  if ac == 1:
    Nst.currc = int(av[0])
  if ac == 2:
    #dpr('ac=%d, ln=%s, av=%s' % (ac, ln, av))
    Nst.currc = int(av[0])
    Nst.backc = int(av[1])
  if (2 < ac) or (ac < 0):
    print('Error: ac=%d, ln=%s' % (ac, ln))
    sys.exit(0)
  Dpr('Nst colormode=%d   c:%d,%d' % (Nst.colormode, Nst.currc, Nst.backc))

def proc_setcolor(ln):
  color_s = ln[len('setcolor')+1:]
  (cr, cg, cb) = color_s.split(',')
  dpr('setcolor: %s %s %s' % (cr, cg, cb))
  Ctbl7[Nst.currc] = (float(cr), float(cg), float(cb))

def proc_pset(ln, command): # PSETA, PSETR
  args = Gv.rm_kakko_comma(ln[len('PSETX')+1:])
  (x, y) = args.split(',')
  if command == 'PSETR':
    add_Nst_lastp.x(float(x), float(y))
  if command == 'PSETA':
    Nst.lastp = (float(x), float(y))
  dpr('%s lastp=(%d,%d)' % (command, Nst.lastp))

def proc_point(ln, command): # POINTR, POINTA
  (ac, av) = Gv.getvec(ln[len('psetX')+1:])
  for (fx,fy) in av:
    if command == 'POINTR':
      Nst.lastp = (Nst.lastp.x + fx, Nst.lastp.y + fy )
    if command == 'POINTA':
      Nst.lastp = (fx, fy)
  dpr('lastp=(%d,%d)' % Nst.lastp)


def proc_line(ln, command): #LINEA, LINER, SLINEA, SLINER
  (ac, av) = Gv.getvec(ln[len(command)+1:])
  vl = []
  if command == 'LINER':
    vl.append(Nst.lastp)
    for xy in av:
      Nst.lastp.x += xy.x
      Nst.lastp.y += xy.y
      vl.append(Nst.lastp)
    # write-data

  if command == 'LINEA':
    vl = av
    vl.insert(0, Nst.lastp)
    Nst.lastp = vl[-1]

  if command == 'SLINEA':
    vl = av
    Nst.lastp = vl[-1]
    # write-data

  return

def proc_rect(ln, command): #RECTF, RECTL, SRECTF, SRECTL
  return


def proc_arc(ln, command): # 'sarcf' or 'sarcl', 'arcf' or 'arcl'
  (ac, av) = Gv.getvec(ln[len(command)+1:])
  #if ac < 2:
  #  print('sarcf too few args:%s' % ln)
  #  sys.exit(0)
  #Dpr('sarcf ac=%d, list vectors' % ac)
  #xx = Nst.lastp.x
  #yy = Nst.lastp.y
  (xx, yy) = Nst.lastp
  points = ''
  for xy in av:
    points += '%4.1f,%4.1f ' % (xx, yy)
    xx += xy[0]
    yy += xy[1]
  Nst.lastp = (xx,yy)
  fill = 'none' if command == 'sarcl' else 'aqua'
  fpw.write('<polygon fill=%s stroke=black points="%s">\n' % (fill, points))

##### Start Main ########

if len(sys.argv) <= 1:
  print('usage: cmd  filename')
  sys.exit(0)

fn = sys.argv[1]
if not fn[-4:] == '.ps1':
  print('not a ps1 file:%s' % fn)
  sys.exit(0)


fn_orig = fn[:-4]

htmlf = fn_orig[:-4] + '.html' if fn_orig[-4] == '.' else 'out.html'
print('fn = %s' % fn)
fp = open(fn, 'r')
fpw = open(htmlf,'w')
fpw.write('<html><body>\n<svg width=100% height=100%>\n')


for ln in fp:
  ln = ln.rstrip()
  if len(ln) < 1 or ln[0] == '#' or ln[0] == '*' or len(ln) < 2:
    continue
  #dpr('line=%s' % ln)
  if _cmp(ln, 'domain'):
    print('domain')

  if _cmp(ln, 'selectcolor'):
    proc_selectcolor(ln)
  if _cmp(ln, 'setcolor'):
    proc_setcolor(ln)

  if _cmp(ln, 'pseta'):
    proc_pset(ln, 'pseta')
  if _cmp(ln, 'psetr'):
    proc_pset(ln, 'psetr')

  if _cmp(ln, 'pointa'):
    proc_point(ln, 'pointa')
  if _cmp(ln, 'pointr'):
    proc_point(ln, 'pointr')
    
  if _cmp(ln, 'slinea'):
    proc_line(ln, 'slinea')
  if _cmp(ln, 'sliner'):
    proc_line(ln, 'sliner')

  if _cmp(ln, 'linea'):
    proc_line(ln, 'linea')
  if _cmp(ln, 'liner'):
    proc_line(ln, 'liner')

  if _cmp(ln, 'srect'):
    proc_srect(ln, 'srect')

  if _cmp(ln,'arcf'):
    proc_arc(ln,'sarcf')
  if _cmp(ln,'arcl'):
    proc_arc(ln,'sarcl')
  if _cmp(ln,'sarcf'):
    proc_arc(ln,'sarcf')
  if _cmp(ln,'sarcl'):
    proc_arc(ln,'sarcl')


  if _cmp(ln, 'srectf'):
    proc_rect(ln, 'srectf')
  if _cmp(ln, 'srectl'):
    proc_rect(ln, 'srectl')
  if _cmp(ln, 'rectf'):
    proc_rect(ln, 'rectf')
  if _cmp(ln, 'rectl'):
    proc_rect(ln, 'rectl')
#
  if _cmp(ln, 'sarcf'):
    proc_arc(ln, 'sarcf')
  if _cmp(ln, 'sarcl'):
    proc_arc(ln, 'sarcl')
  if _cmp(ln, 'arcl'):
    proc_arc(ln, 'arcl')
  if _cmp(ln, 'arcf'):
    proc_arc(ln, 'arcf')

#  if len(ln.split()) < 3:
#    continue
#  (mmdd, shop, price) = ln.split()[:3]

